(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common'], factory) :
	(factory((global.agInput = global.agInput || {}),global.ng.core,global._angular_common));
}(this, (function (exports,_angular_core,_angular_common) { 'use strict';

var InputRefDirective = (function () {
    function InputRefDirective() {
        this.focus = false;
    }
    /**
     * @return {?}
     */
    InputRefDirective.prototype.onFocus = function () {
        this.focus = true;
    };
    /**
     * @return {?}
     */
    InputRefDirective.prototype.onBlur = function () {
        this.focus = false;
    };
    return InputRefDirective;
}());
InputRefDirective.decorators = [
    { type: _angular_core.Directive, args: [{
                selector: '[agInput]'
            },] },
];
/**
 * @nocollapse
 */
InputRefDirective.ctorParameters = function () { return []; };
InputRefDirective.propDecorators = {
    'onFocus': [{ type: _angular_core.HostListener, args: ['focus',] },],
    'onBlur': [{ type: _angular_core.HostListener, args: ['blur',] },],
};

var commonCss = "\n.icon{\n  width:25px;\n  text-align: center;\n  padding-left: 5px;\n  padding-right: 2px;\n  border:none;\n}\n\n:host{\n  border-width: 1px;\n  border-style: solid;\n  padding-bottom: 1px;\n  padding-top: 1px;\n  display: inline-block;\n}\n\n\n:host(.input-focus){\n  outline: none;\n}\n:host /deep/ input{\n  border: none;\n  outline: none;\n  height: 100%;\n  box-sizing: border-box;\n}\n";

var defaultThemeCss = "\n:host{\n  background: white;\n  border-color: lightgray;\n}\n\n:host(.input-focus){\n  border-color: #4D90FE;\n  -webkit-box-shadow: 0px 0px 5px #4D90FE;\n  box-shadow: 0px 0px 5px #4D90FE;\n}\n";

var AgFaInputComponent = (function () {
    function AgFaInputComponent() {
    }
    /**
     * @return {?}
     */
    AgFaInputComponent.prototype.ngAfterContentInit = function () {
        if (!this.input) {
            console.error('ag-fa-input component need input inside its content');
        }
    };
    Object.defineProperty(AgFaInputComponent.prototype, "isInputFocus", {
        /**
         * @return {?}
         */
        get: function () {
            return this.input ? this.input.focus : false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AgFaInputComponent.prototype, "classes", {
        /**
         * @return {?}
         */
        get: function () {
            var /** @type {?} */ cssClasses = {};
            if (this.icon) {
                cssClasses['fa-' + this.icon] = true;
            }
            return cssClasses;
        },
        enumerable: true,
        configurable: true
    });
    return AgFaInputComponent;
}());
AgFaInputComponent.decorators = [
    { type: _angular_core.Component, args: [{
                selector: 'ag-fa-input',
                template: "\n              <i class=\"icon fa\" [ngClass]=\"classes\"></i>\n              <ng-content></ng-content>\n            ",
                styles: [commonCss, defaultThemeCss]
            },] },
];
/**
 * @nocollapse
 */
AgFaInputComponent.ctorParameters = function () { return []; };
AgFaInputComponent.propDecorators = {
    'icon': [{ type: _angular_core.Input },],
    'input': [{ type: _angular_core.ContentChild, args: [InputRefDirective,] },],
    'isInputFocus': [{ type: _angular_core.HostBinding, args: ['class.input-focus',] },],
};

var AgInputModule = (function () {
    function AgInputModule() {
    }
    return AgInputModule;
}());
AgInputModule.decorators = [
    { type: _angular_core.NgModule, args: [{
                declarations: [AgFaInputComponent, InputRefDirective],
                imports: [
                    _angular_common.CommonModule
                ],
                exports: [AgFaInputComponent, InputRefDirective]
            },] },
];
/**
 * @nocollapse
 */
AgInputModule.ctorParameters = function () { return []; };

/**
 * Generated bundle index. Do not edit.
 */

exports.AgInputModule = AgInputModule;
exports.ɵa = AgFaInputComponent;
exports.ɵb = commonCss;
exports.ɵc = defaultThemeCss;
exports.ɵd = InputRefDirective;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ag-input.umd.js.map
