import { Component, ContentChild, Input, HostBinding } from '@angular/core';
import { InputRefDirective } from '../common/input-ref.directive';
import { commonCss } from '../common/common.css';
import { defaultThemeCss } from '../common/default-theme.css';
export class AgFaInputComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngAfterContentInit() {
        if (!this.input) {
            console.error('ag-fa-input component need input inside its content');
        }
    }
    /**
     * @return {?}
     */
    get isInputFocus() {
        return this.input ? this.input.focus : false;
    }
    /**
     * @return {?}
     */
    get classes() {
        const /** @type {?} */ cssClasses = {};
        if (this.icon) {
            cssClasses['fa-' + this.icon] = true;
        }
        return cssClasses;
    }
}
AgFaInputComponent.decorators = [
    { type: Component, args: [{
                selector: 'ag-fa-input',
                template: `
              <i class="icon fa" [ngClass]="classes"></i>
              <ng-content></ng-content>
            `,
                styles: [commonCss, defaultThemeCss]
            },] },
];
/**
 * @nocollapse
 */
AgFaInputComponent.ctorParameters = () => [];
AgFaInputComponent.propDecorators = {
    'icon': [{ type: Input },],
    'input': [{ type: ContentChild, args: [InputRefDirective,] },],
    'isInputFocus': [{ type: HostBinding, args: ['class.input-focus',] },],
};
function AgFaInputComponent_tsickle_Closure_declarations() {
    /** @type {?} */
    AgFaInputComponent.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    AgFaInputComponent.ctorParameters;
    /** @type {?} */
    AgFaInputComponent.propDecorators;
    /** @type {?} */
    AgFaInputComponent.prototype.icon;
    /** @type {?} */
    AgFaInputComponent.prototype.input;
}
//# sourceMappingURL=ag-fa-input.component.js.map