import { Component, ContentChild, Input, HostBinding } from '@angular/core';
import { InputRefDirective } from '../common/input-ref.directive';
import { commonCss } from '../common/common.css';
import { defaultThemeCss } from '../common/default-theme.css';
var AgFaInputComponent = (function () {
    function AgFaInputComponent() {
    }
    /**
     * @return {?}
     */
    AgFaInputComponent.prototype.ngAfterContentInit = function () {
        if (!this.input) {
            console.error('ag-fa-input component need input inside its content');
        }
    };
    Object.defineProperty(AgFaInputComponent.prototype, "isInputFocus", {
        /**
         * @return {?}
         */
        get: function () {
            return this.input ? this.input.focus : false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AgFaInputComponent.prototype, "classes", {
        /**
         * @return {?}
         */
        get: function () {
            var /** @type {?} */ cssClasses = {};
            if (this.icon) {
                cssClasses['fa-' + this.icon] = true;
            }
            return cssClasses;
        },
        enumerable: true,
        configurable: true
    });
    return AgFaInputComponent;
}());
export { AgFaInputComponent };
AgFaInputComponent.decorators = [
    { type: Component, args: [{
                selector: 'ag-fa-input',
                template: "\n              <i class=\"icon fa\" [ngClass]=\"classes\"></i>\n              <ng-content></ng-content>\n            ",
                styles: [commonCss, defaultThemeCss]
            },] },
];
/**
 * @nocollapse
 */
AgFaInputComponent.ctorParameters = function () { return []; };
AgFaInputComponent.propDecorators = {
    'icon': [{ type: Input },],
    'input': [{ type: ContentChild, args: [InputRefDirective,] },],
    'isInputFocus': [{ type: HostBinding, args: ['class.input-focus',] },],
};
function AgFaInputComponent_tsickle_Closure_declarations() {
    /** @type {?} */
    AgFaInputComponent.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    AgFaInputComponent.ctorParameters;
    /** @type {?} */
    AgFaInputComponent.propDecorators;
    /** @type {?} */
    AgFaInputComponent.prototype.icon;
    /** @type {?} */
    AgFaInputComponent.prototype.input;
}
//# sourceMappingURL=ag-fa-input.component.js.map